import java.util.HashSet;
import java.util.List;

// This processing step will indent the HTML tags by checking which ones have
// end tags, and assigning them a level.
public class HtmlIndenter
{
    public HtmlIndenter()
    {

    }

    public void indent( List elements )
    {
        // Add level to each element.
        
        // convert list to an array.
        Object array[] = elements.toArray();
        HashSet tagSet = new HashSet();
        int level = 0;

        // for each element,
        for ( int i = 0; i < array.length; i++ ) {
            // give the element current level.
            HtmlElement elem = (HtmlElement)array[i];
            elem.level = level;
            
            // if the element is a tag,
            if ( elem instanceof HtmlTag ) {
                HtmlTag tag = (HtmlTag)elem;
                // if the element is not an end tag, 
                if ( !tag.isEndTag() ) {
                    // find the element's end tag.
                    HtmlTag endTag = findEndTag( array, i, tag );
                    // if found,
                    if ( endTag != null ) {
                        // increase the level.
                        level++;
                        
                        // add the endtag to the map.
                        tagSet.add( endTag );
                    } 

                // if the tag exists in the map,
                } else if ( tagSet.contains( tag ) ) {
                    // decrease the level.
                    level--;
                    elem.level = level;
                }
            }
        }
    }

    private HtmlTag findEndTag( Object tags[], int index, HtmlTag beginTag )
    {
        String beginName = beginTag.name.toString();
        String endName = "/" + beginName;
        int ignore = 0;

        for ( int i = index + 1; i < tags.length; i++ ) {
            if ( tags[i] instanceof HtmlTag ) {
                HtmlTag tag = (HtmlTag)tags[i];
                if ( tag.name.toString().equals(beginName) ) {
                    ignore++;
                } else if ( tag.name.toString().equals(endName) ) {
                    if ( ignore == 0 ) {
                        return tag;
                    }
                    ignore--;
                }
            }
        }

        return null;
    }
}
