
// This class overrides the prettyoutput class to provide output to html
// instead of text.
public class HtmlOutput extends PrettyOutput
{
    public HtmlOutput()
    {
    }

    protected boolean isLinkStyle( String style ) {
        return style.equals(JS_FUNCTION) ||
            style.equals(JS_CALL);
    }

    protected void beginStyle( String style )
    {
        if ( style.equals( JS_FUNCTION ) ) {
            _curLine.append("<a name=\"" + _tagId + "\">");

        } else if ( style.equals(JS_CALL) ) {
            _curLine.append("<a href=\"#" + _tagId + "\">");

        } else {
            _curLine.append("<span class=" + style + ">");
        }
    }

    protected void finishStyle()
    {
        if ( _curStyle.length() > 0 ) {
            if ( isLinkStyle( _curStyle ) ) {
                _curLine.append("</a>");
            } else {
                _curLine.append("</span>");
            }
        }
    }

    protected void writeHeader()
    {
        output("<html><head><link rel=stylesheet type=\"text/css\" href=\"http://gandolf.homelinux.org/~smhanov/blog/ppstyle.css\">"+
               "</link>"+
               "<body><pre>");
    }

    protected void writeFooter()
    {
        output("<pre></body></html>");
    }

    public void write( String text, String style, int tagId )
    {
        text = text.replaceAll("&", "&amp;");
        text = text.replaceAll("<", "&lt;");
        text = text.replaceAll(">", "&gt;");
        super.write( text, style, tagId );
    }
}
