import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;

public class HtmlTag extends HtmlElement
{
    public HtmlTag()
    {
        attributes = new ArrayList();
        name = new StringBuffer();
    }
    
    public boolean isText() {
        return _isText;
    }

    public boolean isEndTag()
    {
        return name.toString().startsWith("/");
    }

    public String toString() {
        StringBuffer buffer = new StringBuffer();
        buffer.append('<');
        buffer.append(name);

        Iterator iter = attributes.iterator();
        while( iter.hasNext() ) {
            Attribute attribute = (Attribute)iter.next();
            buffer.append(' ');
            buffer.append( attribute.name );
            if ( attribute.value != null ) {
                buffer.append('=');
                buffer.append( attribute.value );
            }
        }
        
        buffer.append('>');

        return buffer.toString();
    }

    public void addAttribute( String name, String value )
    {
        //System.out.println("Add attribute: " +name + "..." + value );
        attributes.add( new Attribute( name, value ) );
    }

    public void addAttribute( String name )
    {
        attributes.add( new Attribute( name, null ) );
    }

    public class Attribute 
    {
        public Attribute( String name, String value )
        {
            this.name = name;
            this.value = value;
        }
        String name;
        String value; // may be null
    }

    private boolean _isText = false;
    public StringBuffer name;
    public List attributes; 
};
