
public class PrettyOutput
{
    protected StringBuffer _curLine;
    protected String _curStyle = "";
    private int _level = 0;
    private boolean _writeHeader = true;

    public static final String SAME_STYLE = "";

    public static final String HTML_PUNC = "html_punc";
    public static final String HTML_TAG_NAME = "html_tag_name";
    public static final String HTML_ATTRIBUTE_NAME = "html_attribute_name";
    public static final String HTML_ATTRIBUTE_VALUE = "html_attribute_value";
    public static final String HTML_TEXT = "html_text";
    
    public static final String JS_KEYWORD = "js_keyword";
    public static final String JS_CONSTANT = "js_constant";
    public static final String JS_FUNCTION = "js_function";
    public static final String JS_CALL = "js_call";

    public PrettyOutput()
    {
        _curLine = new StringBuffer();
    }

    private int _lineLength = 80;
    private int _curLength = 0;
    protected int _tagId;

    public void setLineLength(int length)
    {
        _lineLength = length;
    }

    public void setLevel(int level)
    {
        _level = level;
    }

    protected void indent()
    {
        StringBuffer buffer = new StringBuffer();
        for( int i = 0; i < + _level; i++ ) {
            buffer.append("    ");
        }

        _curLine = buffer;
        _curLength = _curLine.length();
    }
    public void checkWrap()
    {
        if ( _curLength >= _lineLength ) {
            output( _curLine.toString() );
            indent();
        }
    }

    public void newline()
    {
        output( _curLine.toString() );
        indent();
    }

    public void output(String line)
    {
        System.out.println(line);
    }

    public void finish()
    {
        finishStyle();
        output(_curLine.toString());
        indent();
        writeFooter();
    }

    protected void finishStyle()
    {

    }

    protected void writeHeader()
    {
    }

    protected void writeFooter()
    {
    }

    protected void beginStyle( String style )
    {
    }

    public void write( String text, String style ) 
    {
        write( text, style, -1);
    }

    public void write( String text, String style, int tagId )
    {
        if ( _writeHeader ) {
            writeHeader();
            _writeHeader = false;
        }
        _tagId = tagId;
        if ( style.length() > 0 && !style.equals(_curStyle) ) {
            finishStyle();
            _curStyle = style;
            beginStyle( style );
        }
        _curLine.append(text);
        _curLength += text.length();
    }
}
