import java.util.HashMap;

class Tags
{
    public Tags()
    {
        _tags = new HashMap<TagKey, TagValue>();
    }

    private int _nextId = 0;
    private HashMap<TagKey, TagValue> _tags;

    private class TagKey {
        private String tag;
        private String domain;
        public TagKey( String tag, String domain ) {
            this.tag = tag;
            this.domain = domain;
        }

        public int hashCode() {
            return tag.hashCode() + domain.hashCode();
        }

        public boolean equals(Object other) {
            if ( !(other instanceof TagKey) ) {
                return false;
            }

            TagKey oTag = (TagKey)other;
            return tag.equals(oTag.tag) &&
                domain.equals(oTag.domain);
        }
    }

    private class TagValue
    {
        public TagValue( int id ) {
            this.id = id;
        }

        public int id;
    }

    // token --  the text. eg. function name.
    // domain -- the domain. eg. css/javascript
    public int add( String tag, String domain )
    {
        _tags.put( new TagKey( tag, domain), new TagValue( _nextId ) ); 
        return _nextId++;
    }

    public int lookup( String tag, String domain )
    {
        TagValue val = _tags.get(new TagKey( tag, domain ) );
        if ( val != null ) {
            return val.id;
        }
        return -1;
    }

}
